package com.maintain.business.service;

import com.maintain.business.domain.ErpMaterialPicking;
import com.maintain.business.domain.vo.ErpMaterialPickingVo;
import com.maintain.business.domain.bo.ErpMaterialPickingBo;
import com.maintain.common.core.page.TableDataInfo;
import com.maintain.common.core.domain.PageQuery;

import javax.servlet.http.HttpServletResponse;
import java.util.Collection;
import java.util.List;

/**
 * 物料出库Service接口
 *
 * @author liushuai
 * @date 2025-04-03
 */
public interface IErpMaterialPickingService {

    /**
     * 查询物料出库
     */
    ErpMaterialPickingVo queryById(Long id);

    /**
     * 查询物料出库列表
     */
    TableDataInfo<ErpMaterialPickingVo> queryPageList(ErpMaterialPickingBo bo, PageQuery pageQuery);

    /**
     * 查询物料出库列表
     */
    TableDataInfo<ErpMaterialPickingVo> queryPageInfoList(ErpMaterialPickingBo bo, PageQuery pageQuery);

    /**
     * 查询物料出库列表
     */
    List<ErpMaterialPickingVo> queryList(ErpMaterialPickingBo bo);

    /**
     * 新增物料出库
     */
    Boolean insertByBo(ErpMaterialPickingBo bo);

    /**
     * 修改物料出库
     */
    Boolean updateByBo(ErpMaterialPickingBo bo);

    /**
     * 校验并批量删除物料出库信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 批量确认物料出库
     * @param ids
     * @return
     */
    Boolean confirmByIds(Collection<Long> ids);

    /**
     * 新增物料出库退料
     */
    Boolean insertReturnByBo(ErpMaterialPickingBo bo);

    /**
     * 导出物料出库列表
     */
    void export(ErpMaterialPickingBo bo, HttpServletResponse response);
}
